﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.3
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim intChapterId As Int
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim ulvChapters As UltimateListView
	Dim curChapters As Cursor
	Dim f2 As Typeface=Typeface.LoadFromAssets("iransansmobile.ttf")
	Dim curSureh2 As Cursor
	Dim sm As SlidingMenu

	Private Button1 As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	CreateMenu
	Activity.LoadLayout("L")
	Dim cs As CSBuilder
	Activity.Title=cs.Initialize.Typeface(f2).Append("فهرست سور").PopAll
	
	Activity.Color=Colors.White
	
	ulvChapters.Initialize(0,0,0,"ulvChapters")
	ulvChapters.Color=Colors.Transparent
	Activity.AddView(ulvChapters,1,175,-1,-1)

	ulvChapters.AddLayout("layout1","ulvChapters_LayoutCreator","ulvChapters_ContentFiller",50dip,True)
	
	curChapters = Main.sql1.ExecQuery("select * from ChapterProperty")
	
	For i=0 To curChapters.RowCount-1
		ulvChapters.AddItem("layout1",i)
	Next
End Sub

Sub ulvChapters_LayoutCreator(LayoutName As String, LayoutPanel As Panel)
	LayoutPanel.LoadLayout("lytChapters")
End Sub

Sub ulvChapters_ContentFiller(ItemID As Long, LayoutName As String, LayoutPanel As Panel, Position As Int)
	Dim lblnam As Label = LayoutPanel.GetView(0)
	Dim lblnozul As Label = LayoutPanel.GetView(1)
	Dim lblaye As Label = LayoutPanel.GetView(2)
	Dim lblreveal As Label = LayoutPanel.GetView(3)
	Dim namber As Label = LayoutPanel.GetView(4)
	
	curChapters.Position=ItemID
	lblnam.Text=curChapters.GetString("Name")
	lblnozul.Text=curChapters.GetString("Nozol")
	lblaye.Text=curChapters.GetString("Verse")
	lblreveal.Text=curChapters.GetString("revel")
	namber.Text=curChapters.GetString("Id")
	
	LayoutPanel.Tag=curChapters.GetString("Id")
End Sub
Sub ulvChapters_ItemClick(ItemID As Long, Position As Int, ClickedPanel As Panel)
	intChapterId=ClickedPanel.Tag
	curSureh2 = Main.sql1.ExecQuery("select * from ChapterProperty  where Id = " & ClickedPanel.Tag)
	For i = 0 To curSureh2.RowCount-1
		curSureh2.Position=0
		actSureh.Label=curSureh2.GetString("Name")
	Next
	StartActivity(actSureh)
End Sub
Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
'	curChapters.Close
End Sub


Sub Button1_Click
	sm.ShowMenu
End Sub

Sub PanelMenu_ItemClick (Position As Int, Value As Object)

		Select Value
			Case "about"
			MsgboxAsync("ساخته شده توسط گروه برنامه نویسی صادروید", "درباره ما")
			Case "other"
				Dim CafeBazaar As Intent
				CafeBazaar.Initialize(CafeBazaar.ACTION_VIEW , "bazaar://collection?slug=by_author&aid=sadroid")
				StartActivity(CafeBazaar)
		Case "like"
			Dim market As Intent, uri As String
			uri="bazaar://details?id=com.Sadroid.Quran"
			market.Initialize(market.ACTION_EDIT,uri)
			StartActivity(market)

		Case "exit"
				ExitApplication
		End Select


	sm.HideMenus
End Sub

Sub CreateMenu

	sm.Initialize("sm")
	Dim offset As Int
	offset = 30%X
	sm.BehindOffset = offset
	sm.Mode = sm.RIGHT
	Dim LV1 As ListView
	LV1.Initialize("PanelMenu")
	
	sm.Menu.Color = Colors.RGB(56 , 150 , 43)
	LV1.TwoLinesAndBitmap.ItemHeight = 9%Y
	
	LV1.TwoLinesAndBitmap.Label.Gravity = Gravity.RIGHT
	LV1.TwoLinesAndBitmap.Label.Left = 0
	LV1.TwoLinesAndBitmap.Label.Width = 45%X
	LV1.TwoLinesAndBitmap.Label.Height = 4%Y
	LV1.TwoLinesAndBitmap.Label.Top = 2.5%Y
	LV1.TwoLinesAndBitmap.Label.Typeface = Typeface.DEFAULT_BOLD
	LV1.TwoLinesAndBitmap.Label.TextSize = 16
	
	LV1.TwoLinesAndBitmap.ImageView.Width = 4%Y
	LV1.TwoLinesAndBitmap.ImageView.Height = 4%Y
	LV1.TwoLinesAndBitmap.ImageView.Left = 52%X
	LV1.TwoLinesAndBitmap.ImageView.Top = 1.5%Y
	LV1.AddTwoLinesAndBitmap2("درباره ما" , "" , LoadBitmap(File.DirAssets , "mabout.png") , "about")
	LV1.AddTwoLinesAndBitmap2("ارسال نظر" , "" , LoadBitmap(File.DirAssets , "mlike.png") , "like")
	LV1.AddTwoLinesAndBitmap2("سایر برنامه ها" , "" , LoadBitmap(File.DirAssets , "mother.png") , "other")
	LV1.AddTwoLinesAndBitmap2("خروج از برنامه" , "" , LoadBitmap(File.DirAssets , "mexit.png") , "exit")
	

	sm.Menu.AddView(LV1 , 0 , 0 , 100%X - offset , 100%Y)
End Sub

